
cCity = CreateClass()

gMyTicks = gMyTicks or 0
rand = math.random
pi = math.pi
sin = math.sin
cos = math.cos
floor = math.floor
math.randomseed(os.time())


function cCity:init (map)
	print("cCity:Init")
	self.map = map
	self.nextgrow = 0
	-- todo : random forest ?
	self:setProbabilityDistri(0,0,0)
end

function cCity:Step ()
	if (self.nextgrow < gMyTicks) then  
		self.nextgrow = gMyTicks + 1000*0.5
		self:SpawnNewBuilding()
	end
end

function cCity:SumNearbyType		(x,y,r,t) return self:SumNearby(x,y,r,function (b) return b and b.type == t and 1 or 0 end) end
function cCity:SumNearbyTypeLevel	(x,y,r,t) return self:SumNearby(x,y,r,function (b) return b and b.type == t and (b.level or 1) or 0 end) end

function cCity:SumNearby (x,y,r,fun)
	local res = 0
	for ax=x-r,x+r do 
	for ay=y-r,y+r do 
		res = res + fun(self.map:getTile(x,y))
	end
	end
	return res
end

function cCity:setProbabilityDistri(res, ind, com)
	self.proabilityRes = math.floor(res / 10)
	self.proabilityInd = math.floor(ind / 10)
	self.proabilityCom = math.floor(com / 10)
end

function random_do (arr) return rand_from_arr(arr)() end -- key=fun,value=probability 
function rand_from_arr (arr) 
	local sum = 0
	for k,v in pairs(arr) do sum = sum + v end
	local r = rand()*sum -- ():[0;1] 
	for k,v in pairs(arr) do if (r <= v) then return k end r = r - v end	
	local k,v = next(arr)
	return v
end




function cCity:GetTileType (x,y)
	local o = self.map:getTile(x,y)
	return o and o.type
end
function cCity:CalcWayDir (x,y,t)
	local dir
	local ns =	((self:GetTileType(x,y+1) == t) and 1 or 0) + 
				((self:GetTileType(x,y-1) == t) and 1 or 0)
	local we =	((self:GetTileType(x+1,y) == t) and 1 or 0) + 
				((self:GetTileType(x-1,y) == t) and 1 or 0)
	if (ns > we and ns > 0) then dir = 1 end
	if (we > ns and we > 0) then dir = 2 end
	return dir or rand(2)
end

function cCity:CalcGraphic (tile)
	local t = tile and tile.type
	local res = t and (((tile.level or 0) >= 2) and gBuildingType_Image_Level2[t] or gBuildingType_Image_Level1[t]) or gImg_BaseTile
	if (type(res) == "table") then return res[tile.dir or 1] end
	return res
end

function cCity:CorrectDir (x,y,t)
	local tile = self.map:getTile(x,y)
	if (not tile) then return end
	if (tile.type ~= t) then return end
	tile.dir = self:CalcWayDir(x,y,t)
	tile.img = self:CalcGraphic(tile)
end

function cCity:SpawnNewBuildingAtPos (x,y)
	--~ print("cCity:SpawnNewBuildingAtPos",x,y)
	local r = 2
	local t = rand_from_arr({
		[kBuildingType_Residence]	=self.proabilityRes * 2 * (1+self:SumNearbyTypeLevel(x,y,r,kBuildingType_Residence)),
		[kBuildingType_Industry	]	=self.proabilityInd * 2 * (1+self:SumNearbyTypeLevel(x,y,r,kBuildingType_Industry)),
		[kBuildingType_Commerce	]	=self.proabilityCom * 2 * (1+self:SumNearbyTypeLevel(x,y,r,kBuildingType_Commerce)),
--~ 		[kBuildingType_Forest	]	=4*(1+self:SumNearbyTypeLevel(x,y,r,kBuildingType_Forest)),
--~ 		[kBuildingType_Street	]	=2*(1+self:SumNearbyTypeLevel(x,y,r,kBuildingType_Street)),
--~ 		[kBuildingType_Railway	]	=2*(1+self:SumNearbyTypeLevel(x,y,r,kBuildingType_Railway)),
	})
	local dir
	if (t == kBuildingType_Street or t == kBuildingType_Railway) then 
		dir = self:CalcWayDir(x,y,t)
		self:CorrectDir(x-1,y,t)
		self:CorrectDir(x+1,y,t)
		self:CorrectDir(x,y-1,t)
		self:CorrectDir(x,y+1,t)
	end
	local tile = {type=t,level=1,dir=dir}
	tile.img = self:CalcGraphic(tile)
	self.map:setTile(x,y,tile)
	
	self.map:changeTypeStats(tile.type, 1)
end

function cCity:BuildingCheckGrow (x,y,tile)
	if (rand() < 0.1) then 
		tile.level = (tile.level or 0) + 1 
		tile.img = self:CalcGraphic(tile)
		
		self.map:changeTypeStats(tile.type, 1)
	end
end

function cCity:SpawnNewBuilding ()
	--~ print("cCity:SpawnNewBuilding")
	local ang = rand()*2*pi
	local vx,vy = sin(ang),cos(ang)
	local d = 0
	while (true) do 
		local x,y = floor(d*vx),floor(d*vy)
		local p = self.map:getTile(x,y)
		if (p) then
			if (self:BuildingCheckGrow(x,y,p)) then end -- could return here
		else
			self:SpawnNewBuildingAtPos(x,y) 
			return true 
		end
		d = d + 0.5
	end
end



