
cHud = CreateClass()

function cHud:keyDown(key) 
	if key == self.keys.up then self:changeSlider(-1) end
	if key == self.keys.down then self:changeSlider(1) end
	if key == self.keys.left then self:changeActiveValue(-20) end
	if key == self.keys.right then self:changeActiveValue(20) end
end

function cHud:changeActiveValue(delta)
	local sum = 0
	local inactiveCount = 0
	
	local active = self.sliders[self.activeSlider]
	active:addToValue(delta)
	
	if delta > 0 then
		
		for k,v in pairs(self.sliders) do 
			sum = sum + v:getValue() 
			
			if v:getValue() > 0 and k ~= nr then
				inactiveCount = inactiveCount + 1
			end
		end
		
		if sum > 100 then
			local overflow = (sum - 100) / inactiveCount
			
			for k,v in pairs(self.sliders) do 
				if k ~= nr and v:getValue() > 0 then v:addToValue(-overflow) end 
			end
		end
	end
	
	-- update city
	self.city:setProbabilityDistri(
		self.sliders[1]:getValue(),
		self.sliders[2]:getValue(),
		self.sliders[3]:getValue()
	)
end

function cHud:init(city,px,py,keys)
	self.city = city
	
	self.x = px
	self.y = py
	
	local sliderw = 200
	local sliderborder = 10
	
	local barw = 210
	local barborder = 4
	
	local left_slider = 58+5
	local left_bar = 287
	
	self.keys = keys
	
	self.activeSlider = 1
	self.sliders = {
		CreateClassInstance(cSlider, px + left_slider , py + 70, sliderw, sliderborder, 0, 100,
			gImg_SliderBase,gImg_SliderBaseActive,gImg_SliderDotRed),
		CreateClassInstance(cSlider, px + left_slider , py + 136, sliderw, sliderborder, 0, 100,
			gImg_SliderBase,gImg_SliderBaseActive,gImg_SliderDotBlue),
		CreateClassInstance(cSlider, px + left_slider , py + 198, sliderw, sliderborder, 0, 100,
			gImg_SliderBase,gImg_SliderBaseActive,gImg_SliderDotGray),
	}
	
	self.bars = {
		CreateClassInstance(cBar, px + left_bar , py + 76, barw, barborder, gImg_BarBase, gImg_BarInnerRed),
		CreateClassInstance(cBar, px + left_bar , py + 142, barw, barborder, gImg_BarBase, gImg_BarInnerBlue),
		CreateClassInstance(cBar, px + left_bar , py + 204, barw, barborder, gImg_BarBase, gImg_BarInnerGray),
	}
	
	local p = 100 / 3
	
	self:changeSlider(0)
	self.city:setProbabilityDistri(p,p,p)
	
	for k,v in pairs(self.sliders) do v:setValue(p) end
	for k,v in pairs(self.bars) do v:setValue(0) end
end

function cHud:changeSlider(delta)
	local nr = self.activeSlider + delta
	
	for k,v in pairs(self.sliders) do v:setActive(false) end
	
	local l = table.getn(self.sliders)
	
	while nr < 1 do nr = nr + l end
	while nr > l do nr = nr - l end
	
	self.sliders[nr]:setActive(true)
	
	self.activeSlider = nr
end

function cHud:step()
	local map = self.city.map

	for k,v in pairs(self.sliders) do v:step() end
	for k,v in pairs(self.bars) do v:step() end
	
	local maxBuildings = 200

	self.bars[1]:setValue(map:getTypeStats(kBuildingType_Residence) / maxBuildings)
	self.bars[2]:setValue(map:getTypeStats(kBuildingType_Industry) / maxBuildings)
	self.bars[3]:setValue(map:getTypeStats(kBuildingType_Commerce) / maxBuildings)
end

function cHud:draw()
	for k,v in pairs(self.sliders) do v:draw() end
	for k,v in pairs(self.bars) do v:draw() end
end


