
cSlider = CreateClass()

function cSlider:init(px,py,width,border,minValue,maxValue, gfx_slider_base, gfx_slider_active, gfx_slider_dot)
	self.x = px
	self.border = border
	self.y = py
	self.w = width
	self.pos = px
	self.value = minValue
	self.minValue = minValue
	self.maxValue = maxValue
	self.active = false
	
	self.gfx_slider_base = gfx_slider_base
	self.gfx_slider_active = gfx_slider_active
	self.gfx_slider_dot = gfx_slider_dot
	
	self:setValue(self.value)
end

function cSlider:getValue()
	return self.value
end

function cSlider:addToValue(add)
	self:setValue(self.value + add)
end

function cSlider:setValue(value)
	self.value = math.min(math.max(self.minValue, value), self.maxValue)
	
	local relativLocalValue = (self.value - self.minValue) / (self.maxValue - self.minValue)
	
	self.pos = (self.x + self.border) + relativLocalValue * (self.w - 2 * self.border)
end

function cSlider:step()
	
end

function cSlider:setActive(state)
	self.active = state
end

function cSlider:draw()
	completeScreenOnly()
	local w,h = getGfxSourceSize(self.gfx_slider_dot)
	simpleDraw(self.active and self.gfx_slider_active or self.gfx_slider_base, self.x, self.y)
	simpleDraw(self.gfx_slider_dot, self.pos - w/2, self.y)
end


