
cSoundQueue = CreateClass()

function cSoundQueue:init()
	self.queue = CreateClassInstance(cQueue)
	self.currentSound = nil
	self.currentSoundFile = nil
end

function cSoundQueue:startSound(sound)
	print("start", sound)
	self.currentSound = sound
	--~ print("state1", self.currentSound:isStopped())
	love.audio.play(self.currentSound)
	--~ print("state2", self.currentSound:isStopped())
	self.currentSoundFile = sound
end

function cSoundQueue:stopAll()
	if self.currentSound then
		love.audio.stop(self.currentSound)
	end
	
	self.currentSound = nil
	self.queue:removeAll()
end

function cSoundQueue:step()
	if self.currentSound then
		if self.currentSound:isStopped() then
			print("current finished")
			if self.queue:isEmpty() then
				print("requeue")
				love.audio.rewind(self.currentSound)
				love.audio.play(self.currentSound)
			else
				self.currentSound = nil
			end
		end
	end
	
	if self.currentSound == nil and not self.queue:isEmpty() then
		print("start next")
		self:startSound(self.queue:popHead())
	end
end

function cSoundQueue:queueSound(soundFile)
	self.queue:pushTail(love.audio.newSource( soundFile, "static" ))
end
