
function leftScreenOnly()
	love.graphics.setScissor(0, 0, gScreenW / 2, gScreenH)
end

function rightScreenOnly()
	love.graphics.setScissor(gScreenW / 2, 0, gScreenW / 2, gScreenH)
end

function completeScreenOnly()
	love.graphics.setScissor(0, 0, gScreenW, gScreenH)
end

gGfxSourceSizes = {}
function getGfxSourceSize(gfx)
	local arr = gGfxSourceSizes[gfx]
	if (arr) then return unpack(arr) end
end

function newPaddedImage(filename)
    local source = love.image.newImageData(filename)
    local w, h = source:getWidth(), source:getHeight()
    -- Find closest power-of-two.
    local wp = math.pow(2, math.ceil(math.log(w)/math.log(2)))
    local hp = math.pow(2, math.ceil(math.log(h)/math.log(2)))
    
    local gfx = nil
    
    -- Only pad if needed:
    if wp ~= w or hp ~= h then
        local padded = love.image.newImageData(wp, hp)
        padded:paste(source, 0, 0)
        gfx = love.graphics.newImage(padded)
    else
		gfx = love.graphics.newImage(source)
	end
    
    -- originalgroesse in die groessenfunctionen patchen
    local sourceW = source:getWidth()
    local sourceH = source:getHeight()
    
    gGfxSourceSizes[gfx] = {sourceW, sourceH}
    
    return gfx
end

function simpleDraw(gfx, x, y, r, s)
	love.graphics.setColor(255,255,255)
	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.draw(gfx, x,y, r, s, s)
end

function simpleDrawPoint(x,y,radius,r,g,b)
	radius = radius or 3
	r = r or 255
	g = g or 0
	b = b or 0
	
	completeScreenOnly()
	love.graphics.setColor(r,g,b)
	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.rectangle("fill", x - radius, y - radius, 2*radius, 2*radius)
end
