love.filesystem.load("lib.util.lua")()
love.filesystem.load("lib.state.lua")()
love.filesystem.load("lib.gfx.lua")()
love.filesystem.load("lib.game.lua")()

love.filesystem.load("data.img.lua")()
love.filesystem.load("data.sound.lua")()

kBuildingType_Residence		= 1
kBuildingType_Industry		= 2
kBuildingType_Commerce		= 3
kBuildingType_Forest		= 4
kBuildingType_Street		= 5
kBuildingType_Railway		= 6

gBuildingType_Image_Level1 = {
[kBuildingType_Residence]	= gImg_BuildingResidence1,
[kBuildingType_Industry	]	= gImg_BuildingIndustry1,
[kBuildingType_Commerce	]	= gImg_BuildingCommerce1,
--~ [kBuildingType_Forest	]	= gImg_BaseTile1,
--~ [kBuildingType_Street	]	= gImg_Street,
--~ [kBuildingType_Railway	]	= gImg_Train,
}
gBuildingType_Image_Level2 = {
[kBuildingType_Residence]	= gImg_BuildingResidence2,
[kBuildingType_Industry	]	= gImg_BuildingIndustry2,
[kBuildingType_Commerce	]	= gImg_BuildingCommerce2,
}


love.filesystem.load("class.map.lua")()
love.filesystem.load("class.slider.lua")()
love.filesystem.load("class.hud.lua")()
love.filesystem.load("class.bar.lua")()
love.filesystem.load("class.time.lua")()
love.filesystem.load("class.soundqueue.lua")()
love.filesystem.load("class.queue.lua")()

love.filesystem.load("lib.monster.lua")()

love.filesystem.load("citygen.lua")()

function love.load()
	print("load")
	gLoaded = true
	
	gLastTime = love.timer.getTime()
	
	gSoundQueue = CreateClassInstance(cSoundQueue)
	
	switchState(kState_Intro)
end

function love.keypressed(key, unicode)
	--~ print(key, unicode)
	if gState_KeyPressed[gState] then gState_KeyPressed[gState](key, unicode) end
	if key == "escape" then os.exit() end
end

function love.mousepressed( x, y, button ) 
	--~ print(key, unicode)
	if gState_MousePressed[gState] then gState_MousePressed[gState](x,y,button) end
end

function love.draw()
	if gState_Draw[gState] then gState_Draw[gState]() end
end

gStepMe = {}
function RegisterStepMe (o) gStepMe[o] = true end

function love.update(dt)
	gTime = love.timer.getTime( ) -- in seconds
	gDeltaTime = gTime - (gLastTime or gTime)
	gLastTime = gTime
	gMyTicks = gTime * 1000 -- in milliseconds
	StepGlobalFireSound()
	
	--~ if (gMusic_PlayDirectManualLoop and gTime > gMusicNextPlay) then gMusicNextPlay = gTime + gMusicLength love.audio.play(gMusic) end
	if gState_Update[gState] then gState_Update[gState](dt) end
	for ps,v in pairs(gParticleSystemStepMe) do ps:update(dt) end
	for o,v in pairs(gStepMe) do if (o:Step(dt)) then gStepMe[o] = nil end end
	
	gSoundQueue:step()
end