

function DrawTimeCircle (x,y,relt,bEvilMode)
	x = x - 2
	y = y - 18
	local r = 60
	if (bEvilMode) then relt = 1 - relt end
	love.graphics.setColor(0,0,0,255)
	love.graphics.circle("fill",x,y,r+3,17)
	love.graphics.setColor(255,255,255,255)
	love.graphics.circle("fill",x,y,r,17)
	if (bEvilMode) then
			love.graphics.setColor(255,0,0,255)
	else	love.graphics.setColor(0,255,0,255)
	end
	love.graphics.circle("fill",x,y,r*relt,17)
	--~ love.graphics.polygon("fill",vertices)
	love.graphics.setColor(255,255,255,255)
end

------------------------- menu ------------------
gState_Draw[kState_Menu] = function()
	gMap1:draw()
	gMap2:draw()
	
	love.graphics.draw(gImgGui_City,0,0)
	
	DrawTimeCircle(gScreenW/2,gScreenH/2,gTimeRelative)
	
	gHud1:draw()
	gHud2:draw()
	
	completeScreenOnly()
	if gControllImage then simpleDraw(gControllImage, 0, 0) end
	
	gTimeDisplay:draw()
end

gState_Update[kState_Menu] = function()
	gCity1:Step()
	gCity2:Step()
	
	gMap1:step()
	gMap2:step()
	
	gHud1:step()
	gHud2:step()

	gTimeDisplay:step()
end

gState_Leave[kState_Menu] = function()
	gControllImage = nil
end

gState_Enter[kState_Menu] = function()
	gStateStartT_Menu = gMyTicks
	gSoundQueue:stopAll()
	gSoundQueue:queueSound("snd/mx_simloop.ogg")

	gMap1 = CreateClassInstance(cMap, 0, 0, gScreenW / 2, 512)	
	gMap2 = CreateClassInstance(cMap, gScreenW / 2, gScreenH - 512, gScreenW / 2, 512)	

	gCity1 = CreateClassInstance(cCity,gMap1)
	gCity2 = CreateClassInstance(cCity,gMap2)
	
	gHud1 = CreateClassInstance(cHud, gCity1, 0, 512, {up = "w", down = "s", left = "a", right = "d"})
	gHud2 = CreateClassInstance(cHud, gCity2, gScreenW / 2, -30, {up = "up", down = "down", left = "left", right = "right"})
	
	gTimeDisplay = CreateClassInstance(cTimeDisplay)

	gControllImage = gImg_Schild1Screen
	InvokeLater(function ()
					gControllImage = nil
				end, 5 * 1000)
end

gState_MousePressed[kState_Menu] = function(x,y,button)
end

gState_KeyPressed[kState_Menu] = function(key, unicode)
	if key == "m" then switchState(kState_Monster) end
	
	if gHud1 then gHud1:keyDown(key) end
	if gHud2 then gHud2:keyDown(key) end
	
	--~ if key == "up" then gMenuCurrentSelection = gMenuCurrentSelection - 1 end
	--~ if key == "down" then gMenuCurrentSelection = gMenuCurrentSelection + 1 end
	--~ gMenuCurrentSelection = math.max(1,math.min(kNumberOfLevels,gMenuCurrentSelection))
	--~ 
	--~ if key == "return" then	
		--~ for i = 1,kNumberOfLevels do 
			--~ if gMenuCurrentSelection == i then loadLevel(i) end
		--~ end
	--~ end
end
